﻿using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ChangingAppearanceSelectedRows
{
    public class MyDrawFilter : IUIElementDrawFilter
    {
        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            UltraGridCell aCell = (UltraGridCell)drawParams.Element.SelectableItem;

            if (aCell.Selected || aCell.Row.Selected || aCell.Column.Header.Selected)
            {
                if ((aCell.HasAppearance) && (!aCell.Appearance.BackColor.IsEmpty))
                {
                    drawParams.AppearanceData.BackColor = aCell.Appearance.BackColor;
                }
                else if ((aCell.Row.HasCellAppearance) && (!aCell.Row.CellAppearance.BackColor.IsEmpty))
                {
                    drawParams.AppearanceData.BackColor = aCell.Row.CellAppearance.BackColor;
                }
                else if ((aCell.Column.HasCellAppearance) && (!aCell.Column.CellAppearance.BackColor.IsEmpty))
                {
                    drawParams.AppearanceData.BackColor = aCell.Column.CellAppearance.BackColor;
                }
            }

            return true;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            if((drawParams.Element is EmbeddableUIElementBase) && (drawParams.Element.GetContext(typeof(UltraGridCell)) != null))
            {
                return DrawPhase.BeforeDrawBackColor;
            }
            return DrawPhase.None;
        }
    }
}
